import pandas as pd
import numpy as np
from matplotlib import pyplot as plt
# Import and display  dataset
desc = pd.read_csv('ChemoInformaticsData_mod_bact_tr.csv')
# desc.head()
from sklearn.linear_model import LinearRegression

# Build linear regression model using descriptors as predictors
# Split data into predictors X and output Y
predictors = ['h_logS', 'h_log_dbo', 'h_log_pbo', 'h_mr', 'h_pavgQ', 'h_pKa', 'h_pKb', 'h_pstates', 'h_pstrain', 'Kier1', 'Kier2', 'Kier3', 'KierA1', 'KierA2', 'KierA3', 'KierFlex', 'lip_acc', 'lip_don', 'logP(o/w)', 'logS', 'mr', 'nmol', 'npr1', 'npr2', 'opr_brigid', 'opr_leadlike', 'opr_nring', 'opr_nrot', 'opr_violation', 'PC+', 'PC-', 'PEOE_PC+', 'PEOE_PC-', 'PEOE_RPC+', 'PEOE_RPC-', 'PEOE_VSA+0', 'PEOE_VSA+1', 'PEOE_VSA+2', 'PEOE_VSA+3', 'PEOE_VSA+4', 'PEOE_VSA+5', 'PEOE_VSA+6', 'PEOE_VSA-0', 'PEOE_VSA-1', 'PEOE_VSA-2', 'PEOE_VSA-3', 'PEOE_VSA-4', 'PEOE_VSA-5', 'PEOE_VSA-6', 'PEOE_VSA_FHYD', 'PEOE_VSA_FNEG', 'PEOE_VSA_FPNEG', 'PEOE_VSA_FPOL', 'PEOE_VSA_FPOS', 'PEOE_VSA_FPPOS', 'PEOE_VSA_HYD', 'PEOE_VSA_NEG', 'PEOE_VSA_PNEG', 'PEOE_VSA_POL', 'PEOE_VSA_POS', 'PEOE_VSA_PPOS', 'petitjean', 'petitjeanSC', 'PM3_dipole', 'pmi', 'pmi1', 'pmi2', 'pmi3', 'pmiX', 'pmiY', 'pmiZ', 'pro_app_charge', 'pro_asa_hph', 'pro_asa_hyd', 'pro_asa_vdw', 'pro_coeff_280', 'pro_coeff_diff', 'pro_coeff_fric', 'pro_debye', 'pro_dipole_moment', 'pro_eccen', 'pro_helicity', 'pro_henry', 'pro_hyd_moment', 'pro_mass', 'pro_mobility', 'pro_net_charge', 'pro_patch_hyd', 'pro_patch_hyd_1', 'pro_patch_hyd_2', 'pro_patch_hyd_3', 'pro_patch_hyd_4', 'pro_patch_hyd_5', 'pro_patch_hyd_n', 'pro_patch_ion', 'pro_patch_ion_1', 'pro_patch_ion_2', 'pro_patch_ion_3', 'pro_patch_ion_4', 'pro_patch_ion_5', 'pro_patch_pos', 'pro_patch_pos_1', 'pro_patch_pos_2', 'pro_patch_pos_3', 'pro_patch_pos_4', 'pro_patch_pos_5', 'pro_patch_pos_n', 'pro_pI_3D', 'pro_pI_seq', 'pro_r_gyr', 'pro_r_solv', 'pro_sed_const', 'pro_volume', 'pro_zdipole', 'pro_zeta', 'pro_zquadrupole', 'Q_PC+', 'Q_PC-', 'Q_RPC+', 'Q_RPC-', 'Q_VSA_FHYD', 'Q_VSA_FNEG', 'Q_VSA_FPNEG', 'Q_VSA_FPOL', 'Q_VSA_FPOS', 'Q_VSA_FPPOS', 'Q_VSA_HYD', 'Q_VSA_NEG', 'Q_VSA_PNEG', 'Q_VSA_POL', 'Q_VSA_POS', 'Q_VSA_PPOS', 'radius', 'reactive', 'rgyr', 'rings', 'RPC+', 'RPC-', 'rsynth', 'SlogP', 'SlogP_VSA0', 'SlogP_VSA1', 'SlogP_VSA2', 'SlogP_VSA3', 'SlogP_VSA4', 'SlogP_VSA5', 'SlogP_VSA6', 'SlogP_VSA7', 'SlogP_VSA8', 'SlogP_VSA9', 'SMR', 'SMR_VSA0', 'SMR_VSA1', 'SMR_VSA2', 'SMR_VSA3', 'SMR_VSA4', 'SMR_VSA5', 'SMR_VSA6', 'SMR_VSA7', 'std_dim1', 'std_dim2', 'std_dim3', 'TPSA', 'VAdjEq', 'VAdjMa', 'VDistEq', 'VDistMa', 'vdw_area', 'vdw_vol', 'vol', 'VSA', 'vsa_acc', 'vsa_acid', 'vsa_base', 'vsa_don', 'vsa_hyd', 'vsa_other', 'vsa_pol', 'vsurf_A', 'vsurf_CP', 'vsurf_CW1', 'vsurf_CW2', 'vsurf_CW3', 'vsurf_CW4', 'vsurf_CW5', 'vsurf_CW6', 'vsurf_CW7', 'vsurf_CW8', 'vsurf_D1', 'vsurf_D2', 'vsurf_D3', 'vsurf_D4', 'vsurf_D5', 'vsurf_D6', 'vsurf_D7', 'vsurf_D8', 'vsurf_DD12', 'vsurf_DD13', 'vsurf_DD23', 'vsurf_DW12', 'vsurf_DW13', 'vsurf_DW23', 'vsurf_EDmin1', 'vsurf_EDmin2', 'vsurf_EDmin3', 'vsurf_EWmin1', 'vsurf_EWmin2', 'vsurf_EWmin3', 'vsurf_G', 'vsurf_HB1', 'vsurf_HB2', 'vsurf_HB3', 'vsurf_HB4', 'vsurf_HB5', 'vsurf_HB6', 'vsurf_HB7', 'vsurf_HB8', 'vsurf_HL1', 'vsurf_HL2', 'vsurf_ID1', 'vsurf_ID2', 'vsurf_ID3', 'vsurf_ID4', 'vsurf_ID5', 'vsurf_ID6', 'vsurf_ID7', 'vsurf_ID8', 'vsurf_IW1', 'vsurf_IW2', 'vsurf_IW3', 'vsurf_IW4', 'vsurf_IW5', 'vsurf_IW6', 'vsurf_IW7', 'vsurf_IW8', 'vsurf_R', 'vsurf_S', 'vsurf_V', 'vsurf_W1', 'vsurf_W2', 'vsurf_W3', 'vsurf_W4', 'vsurf_W5', 'vsurf_W6', 'vsurf_W7', 'vsurf_W8', 'vsurf_Wp1', 'vsurf_Wp2', 'vsurf_Wp3', 'vsurf_Wp4', 'vsurf_Wp5', 'vsurf_Wp6', 'vsurf_Wp7', 'vsurf_Wp8', 'Weight', 'weinerPath', 'weinerPol', 'zagreb', 'pH', 'patch_hyd', 'patch_hyd_1', 'patch_hyd_2', 'patch_hyd_3', 'patch_hyd_4', 'patch_hyd_5', 'patch_hyd_n', 'patch_pos', 'patch_pos_1', 'patch_pos_2', 'patch_pos_3', 'patch_pos_4', 'patch_pos_5', 'patch_pos_n', 'patch_neg', 'patch_neg_1', 'patch_neg_2', 'patch_neg_3', 'patch_neg_4', 'patch_neg_5', 'patch_neg_n', 'patch_ion', 'patch_ion_1', 'patch_ion_2', 'patch_ion_3', 'patch_ion_4', 'patch_ion_5', 'patch_ion_n', 'ens_charge', 'ens_dipole', 'mass', 'debye', 'pI_seq', 'pI_3D', 'coeff_280', 'coeff_fric', 'coeff_diff', 'r_gyr', 'r_solv', 'sed_const', 'eccen', 'asa_vdw', 'asa_hyd', 'asa_hph', 'volume', 'mobility', 'helicity', 'henry', 'net_charge', 'app_charge', 'dipole_moment', 'hyd_moment', 'zeta', 'zdipole', 'zquadrupole']

X = desc[predictors]
y = desc['bact']

# Initialise and fit model
lr = LinearRegression()
model = lr.fit(X, y)

print(f'alpha = {model.intercept_}')
print(f'betas = {model.coef_}')

model.predict(X)

desc_p = pd.read_csv('ChemoInformaticsData_mod_bact_pred.csv')
# desc_p.head()

new_X = desc_p[predictors]
print(model.predict(new_X))

R2 = model.score(new_X, model.predict(new_X))
print(f'R2 score =  {R2}')
