import pandas as pd
# modified from https://stackabuse.com/implementing-pca-in-python-with-scikit-learn/
dataset = pd.read_csv("ChemoInformaticsData_mod_bact_tr_pca.csv", header=0, index_col=0)
dataset.head()

X = dataset.drop('bact', 1)
y = dataset['bact']
# The script above stores the feature sets into the X variable and the series of 
# corresponding labels in to the y variable.

# Splitting the dataset into the Training set and Test set
from sklearn.model_selection import train_test_split

X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.25, random_state=0)

from sklearn.preprocessing import StandardScaler

sc = StandardScaler()
X_train = sc.fit_transform(X_train)
X_test = sc.transform(X_test)

from sklearn.decomposition import PCA

pca = PCA()
X_train = pca.fit_transform(X_train)
X_test = pca.transform(X_test)

explained_variance = pca.explained_variance_ratio_

from sklearn.decomposition import PCA

pca = PCA(n_components=1)
X_train = pca.fit_transform(X_train)
X_test = pca.transform(X_test)

from sklearn.ensemble import RandomForestClassifier

classifier = RandomForestClassifier(max_depth=2, random_state=0)
classifier.fit(X_train, y_train)

# Predicting the Test set results
y_pred = classifier.predict(X_test)

# Performance Evaluation
from sklearn.metrics import confusion_matrix as matching_matrix
from sklearn.metrics import accuracy_score

mm = matching_matrix(y_test, y_pred)
print(mm)
print('Accuracy' , accuracy_score(y_test, y_pred))

y_pred

y_test

from sklearn.decomposition import PCA

# pca = PCA(n_components=2)
pca = PCA(n_components=1)
X_train = pca.fit_transform(X_train)
X_test = pca.transform(X_test)
